<script setup>
import { ref, computed, onMounted, onBeforeUnmount, nextTick } from "vue";

const $emit = defineEmits(["scroll"]);
const tagAndTagSpacing = 0; // tagAndTagSpacing
const left = ref(0);
const scrollContainer = ref();

const wrap = computed(() => {
  return scrollContainer.value.$refs.wrap;
});
// onMounted(() => {
//   console.log("?", scrollContainer.value, wrap, "=============");

//   // wrap.addEventListener("scroll", emitScroll, true);

//   nextTick(() => {
//     // 尝试找到滚动容器，这里假设它是 scrollContainer 的直接子元素  
//     // 注意：这取决于 Element Plus 的具体实现，可能需要调整  
//     const scrollElement = scrollContainer.value.$el;
//     if (scrollElement) {  
//       scrollElement.addEventListener('scroll', emitScroll, { passive: true });  
//     }  
//   });
// });
// onBeforeUnmount(() => {
//   wrap.removeEventListener("scroll", emitScroll);
// });

function handleScroll(e) {
  const eventDelta = e.wheelDelta || -e.deltaY * 40;
  scrollContainer.value.scrollLeft = wrap.scrollLeft + eventDelta / 4;
}
function emitScroll() {
  $emit("scroll");
}
// function moveToTarget(currentTag) {
//   const $container = $refs.scrollContainer.$el;
//   const $containerWidth = $container.offsetWidth;
//   const $scrollWrapper = scrollWrapper;
//   const tagList = $parent.$refs.tag;

//   let firstTag = null;
//   let lastTag = null;

//   // find first tag and last tag
//   if (tagList.length > 0) {
//     firstTag = tagList[0];
//     lastTag = tagList[tagList.length - 1];
//   }

//   if (firstTag === currentTag) {
//     $scrollWrapper.scrollLeft = 0;
//   } else if (lastTag === currentTag) {
//     $scrollWrapper.scrollLeft = $scrollWrapper.scrollWidth - $containerWidth;
//   } else {
//     // find preTag and nextTag
//     const currentIndex = tagList.findIndex((item) => item === currentTag);
//     const prevTag = tagList[currentIndex - 1];
//     const nextTag = tagList[currentIndex + 1];

//     // the tag's offsetLeft after of nextTag
//     const afterNextTagOffsetLeft =
//       nextTag.$el.offsetLeft + nextTag.$el.offsetWidth + tagAndTagSpacing;

//     // the tag's offsetLeft before of prevTag
//     const beforePrevTagOffsetLeft = prevTag.$el.offsetLeft - tagAndTagSpacing;

//     if (afterNextTagOffsetLeft > $scrollWrapper.scrollLeft + $containerWidth) {
//       $scrollWrapper.scrollLeft = afterNextTagOffsetLeft - $containerWidth;
//     } else if (beforePrevTagOffsetLeft < $scrollWrapper.scrollLeft) {
//       $scrollWrapper.scrollLeft = beforePrevTagOffsetLeft;
//     }
//   }
// }
</script>
<template>
  <el-scrollbar
    ref="scrollContainer"
    :vertical="false"
    class="scroll-container"
  >
    <!-- @wheel.prevent="handleScroll" -->
    <slot />
  </el-scrollbar>
</template>

<style lang="less" scoped>
.scroll-container {
  white-space: nowrap;
  position: relative;
  overflow: hidden;
  width: 100%;
  :deep(.el-scrollbar__bar) {
    bottom: 0px;
  }
  :deep(.el-scrollbar__wrap) {
    overflow-x: hidden;
  }
}

.scroll-container::-webkit-scrollbar {
  height: 0;
}

.scroll-container::-webkit-scrollbar-thumb {
  /* 滚动条里面小方块 */
  border-radius: 10px;
  -webkit-box-shadow: none;
  background: none;
}
.scroll-container::-webkit-scrollbar-track {
  /* 滚动条里面轨道 */
  -webkit-box-shadow: none;
  border-radius: 10px;
  background: none;
}
</style>
